%define		pname djbdns
%define		pversion 1.05
%define 	bversion 148
%define		rpmrelease iworx
%define		djbdnsdir %{_localstatedir}/djbdns

%define 	debug_package %{nil}

# Distro Statements
%define		oscode rhe%{?rhel}x

%if 0%{?rhel} <= 7
%define 	ostype RedHat Enterprise %{?rhel}.x
%endif


%if 0%{?rhel} >= 8
%define 	ostype Almalinux %{?rhel}.x
%endif

%define	release %{bversion}.%{oscode}.%{rpmrelease}

############### RPM ################################

Summary:	A stable dns server
Name:		%{pname}
Version:	%{pversion}
Release: 	%{release}
License:	D. J. Bernstein

Group:		System/Servers
Source0:	%{name}-%{pversion}.tar.gz
URL:		http://cr.yp.to

Distribution:	InterWorx-HAL
Vendor:         INTERWORX L.L.C
Packager:	Paul Oehler <poehler@interworx.com>

BuildRoot:	%{_tmppath}/%{name}-%{version}-root

Provides:	dnsserver
Conflicts:	bind
Conflicts:	caching-nameserver
Requires:		findutils
Requires:       chkconfig
Requires:       daemontools
Requires:       fileutils
%define         ccflags %{optflags}
%define         ldflags %{optflags}

Source1:	djbdns.init.bz2
Source2:    djbdns-delay-restart.sh

Patch0:	    djbdns-1.05-test23.diff.bz2
Patch1:     djbdns-1.05-ipv6-Makefile.patch
Patch2:     djbdns-1.05-root-servers.patch
Patch3:     djbdns-1.05-increase-udpbuf.patch
Patch4:     djbdns-1.05-splittxt.patch
Patch5:     djbdns-1.05-d-root.patch
Patch6:     djbdns-1.05-CVE-2012-1191.patch
Patch7:     djbdns-1.05-tcp-reuse.patch
Patch8:     djbdns-1.05-maxloop.patch
Patch9:     djbdns-interworx-disable-chkshsgr.patch

%description
djbdns is a collection of Domain Name System tools. It includes
software for all the fundamental DNS operations.
Includes "Fefe's patches for IPv6 with djbdns"
http://www.fefe.de/dns/djbdns-1.05-test23.diff.bz2
Includes patch to have TXT records split at 255 instead of 127 bytes.

%prep

if [ -n %{buildroot} ] ; then rm -rf %{buildroot} ; fi

if [ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] ; then rm -rf $RPM_BUILD_DIR/%{name}-%{pversion} ; fi

%setup -q

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p2

# Display compilation flags and OS with colors ;)

if [ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] ; then rm -f %{_tmppath}/%{name}-%{pversion}-show_flags ; fi
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
if [ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] ; then rm -f %{_tmppath}/%{name}-%{pversion}-show_flags ; fi

# We have gcc written in a temp file
export CC="gcc %{ccflags}"

%build

mkdir -p %{buildroot}

# We have gcc written in a temp file
echo "gcc %{ccflags}"    | sed 's/ -s / /' 	>conf-cc
echo "gcc -s %{ldflags}" | sed 's/ -s / /' 	>conf-ld
echo "/usr"									>conf-home

# GLIBC fix
echo "Fixing errno.h for new GLIBC"
echo "#include <errno.h>" >> error.h


# build djbdns
make %{?_smp_mflags}

%install

rm -rf %{buildroot}

# setup the dir structure
mkdir -p %{buildroot}/bin
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_sysconfdir}/init.d
mkdir -p %{buildroot}%{_sysconfdir}/sysconfig
mkdir -p %{buildroot}%{_mandir}/man1
mkdir -p %{buildroot}%{_mandir}/man5
mkdir -p %{buildroot}%{_mandir}/man8

# install the bins
cp tinydns-get   %{buildroot}%{_bindir}
cp tinydns-data  %{buildroot}%{_bindir}
cp tinydns-edit  %{buildroot}%{_bindir}
cp rbldns-data   %{buildroot}%{_bindir}
cp pickdns-data  %{buildroot}%{_bindir}
cp axfr-get      %{buildroot}%{_bindir}

cp dnsip         %{buildroot}%{_bindir}
cp dnsipq        %{buildroot}%{_bindir}
cp dnsname       %{buildroot}%{_bindir}
cp dnstxt        %{buildroot}%{_bindir}
cp dnsmx         %{buildroot}%{_bindir}

cp dnscache-conf %{buildroot}%{_bindir}
cp tinydns-conf  %{buildroot}%{_bindir}
cp walldns-conf  %{buildroot}%{_bindir}
cp rbldns-conf   %{buildroot}%{_bindir}
cp pickdns-conf  %{buildroot}%{_bindir}
cp axfrdns-conf  %{buildroot}%{_bindir}

cp dnscache      %{buildroot}%{_bindir}
cp tinydns       %{buildroot}%{_bindir}
cp walldns       %{buildroot}%{_bindir}
cp rbldns        %{buildroot}%{_bindir}
cp pickdns       %{buildroot}%{_bindir}
cp axfrdns       %{buildroot}%{_bindir}

cp dnsfilter     %{buildroot}%{_bindir}
cp random-ip     %{buildroot}%{_bindir}
cp dnsqr         %{buildroot}%{_bindir}
cp dnsq          %{buildroot}%{_bindir}
cp dnstrace      %{buildroot}%{_bindir}
cp dnstracesort  %{buildroot}%{_bindir}

cp dnsroots.global    %{buildroot}%{_sysconfdir}/

cp %{SOURCE1} %{buildroot}%{_sysconfdir}/init.d/djbdns.bz2
cp %{SOURCE2} %{buildroot}/usr/bin/djbdns-delay-restart.sh
chmod 700 %{buildroot}/usr/bin/djbdns-delay-restart.sh

bunzip2 %{buildroot}%{_sysconfdir}/init.d/djbdns.bz2

%clean
if [ -n "%{buildroot}" -a "%{buildroot}" != / ] ; then rm -rf %{buildroot} ; fi
if [ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] ; then rm -rf $RPM_BUILD_DIR/%{name}-%{pversion} ; fi

%pre

%{__grep} "^dnscache:" /etc/passwd >/dev/null || \
	/usr/sbin/useradd -d %{djbdnsdir} -s /bin/true -c %{name} -r -m dnscache 2>/dev/null
%{__grep} "^dnslog:"   /etc/passwd >/dev/null || \
	/usr/sbin/useradd -d %{djbdnsdir} -s /bin/true -c %{name} -r -m dnslog 2>/dev/null
%{__grep} "^tinydns:"  /etc/passwd >/dev/null || \
	/usr/sbin/useradd -d %{djbdnsdir} -s /bin/true -c %{name} -r -m tinydns 2>/dev/null

%post

# setup a caching dns resolver
if [ ! -d %{djbdnsdir}/dnscache ]; then
	dnscache-conf dnscache dnslog %{djbdnsdir}/dnscache 127.0.0.1
	ln -fs %{djbdnsdir}/dnscache /service/dnscache
fi

# setup the skel of a recursive server for
# us to use later on
if [ ! -d %{djbdnsdir}/tinydns ]; then
	tinydns-conf tinydns dnslog %{djbdnsdir}/tinydns 1.2.3.4
	rm -rf %{djbdnsdir}/tinydns/env
	rm -rf %{djbdnsdir}/tinydns/log
	rm -f  %{djbdnsdir}/tinydns/run
fi

if [ "$1" == "1" ]; then
  #only do this for initial install
  /usr/bin/djbdns-delay-restart.sh 60 || : &
fi

# See InterWorx ticket #4613, update to h.root-servers.net IPv4
find /var/djbdns/ -type f -name @ | xargs -n1 sed -i 's/128.63.2.53/198.97.190.53/'

%preun
if [ "$1" == "0" ]; then
   echo
   echo "WARNING: djbdns package removal request denied.  This package is required by Interworx."
   echo
   exit 1
fi

%postun

#
# if we're erasing (i.e. not upgrading)
if [ "$1" = "0" ]; then
	%{__grep} "^dnscache:" /etc/passwd >/dev/null || userdel -r dnscache
	%{__grep} "^dnslog:"   /etc/passwd >/dev/null || userdel -r dnslog
	%{__grep} "^tinydns:"  /etc/passwd >/dev/null || userdel -r tinydns

	rm -rf %{djbdnsdir}/dnscache
	rm -rf %{djbdnsdir}/tinydns
	rm -rf /service/dnscache
	rm -rf /service/tinydns*
fi

%posttrans
# this is needed because of a stupid problem in 
# an ancient djbdns rpm that did "stop" in %preun
service djbdns start > /dev/null 2>&1

%files
%defattr(-,root,root)

%attr(0755,root,root) %{_bindir}/tinydns-get
%attr(0755,root,root) %{_bindir}/tinydns-data
%attr(0755,root,root) %{_bindir}/tinydns-edit
%attr(0755,root,root) %{_bindir}/rbldns-data
%attr(0755,root,root) %{_bindir}/pickdns-data
%attr(0755,root,root) %{_bindir}/axfr-get
%attr(0755,root,root) %{_bindir}/dnsip
%attr(0755,root,root) %{_bindir}/dnsipq
%attr(0755,root,root) %{_bindir}/dnsmx
%attr(0755,root,root) %{_bindir}/dnsname
%attr(0755,root,root) %{_bindir}/dnstxt

%attr(0700,root,root) %{_bindir}/djbdns-delay-restart.sh

%attr(0755,root,root) %{_bindir}/axfrdns
%attr(0755,root,root) %{_bindir}/axfrdns-conf
%attr(0755,root,root) %{_bindir}/dnscache
%attr(0755,root,root) %{_bindir}/dnscache-conf
%attr(0755,root,root) %{_bindir}/dnsfilter
%attr(0755,root,root) %{_bindir}/dnsq
%attr(0755,root,root) %{_bindir}/dnsqr
%attr(0755,root,root) %{_bindir}/dnstrace
%attr(0755,root,root) %{_bindir}/dnstracesort
%attr(0755,root,root) %{_bindir}/pickdns
%attr(0755,root,root) %{_bindir}/pickdns-conf
%attr(0755,root,root) %{_bindir}/random-ip
%attr(0755,root,root) %{_bindir}/rbldns
%attr(0755,root,root) %{_bindir}/rbldns-conf
%attr(0755,root,root) %{_bindir}/tinydns
%attr(0755,root,root) %{_bindir}/tinydns-conf
%attr(0755,root,root) %{_bindir}/walldns
%attr(0755,root,root) %{_bindir}/walldns-conf
%attr(0644,root,root) %{_sysconfdir}/dnsroots.global
%attr(0700,root,root) %{_sysconfdir}/init.d/djbdns

%changelog
* Tue Dec 21 2021 Joseph Purkis <jpurkis@interworx.com>
- Remove ancient dynamic gcc resolution (always resulted in just 'gcc')
- Cleaned up old Distros
* Wed Aug 25 2021 Joseph Purkis <jpurkis@interworx.com>
- Adding Almalinux build
* Fri Dec 22 2017 Paul Oehler <poehler@interworx.com>
- Upped maxloop to 2500, letsencrypt domains failing to resolve
* Tue Oct 10 2017 Paul Oehler <poehler@interworx.com>
- Added djbdns-1.05-maxloop.patch
- Added djbdns-1.05-tcp-reuse.patch
* Mon Dec 7 2015 Tim College <tcollege@interworx.com>
- Updated IPv4 of h.root-servers.net
* Thu Nov 13 2014 Matthew Parmelee <mparmelee@interworx.com>
- Updated for RHEL7x.
* Tue Feb 25 2014 Paul Oehler <poehler@interworx.com>
- removed unneeded restart in posttrans scriptlet
* Tue Mar 26 2013 Matthew Parmelee <mparmelee@interworx.com>
- Patched for CVE-2012-1191.
* Tue Mar 26 2013 Matthew Parmelee <mparmelee@interworx.com>
- Updated D-root IPv4 address.
* Sat Jun 30 2012 Dan Motles <dmotles@interworx.com>
- Modified init scripts to be LSB compliant for HA
* Tue Nov 15 2011 Matthew Parmelee <mparmelee@interworx.com>
- Added handling for manually disabled DNS services.
* Mon Oct 25 2011 Paul Oehler <poehler@interworx.com>
- Added splittxt patch to increase txt split size at 255 instead of 127.
* Mon Oct 11 2010 Paul Oehler <poehler@interworx.com>
- Increased dns_transmit.c udpbuf to 4097 to deal with large udp packets
* Sun Oct 03 2010 Paul Oehler <poehler@interworx.com>
- Added uninstall blocker preun script
* Thu Sep 23 2010 Paul Oehler <poehler@interworx.com>
- added ipv6 support and updated root servers
* Tue Sep 14 2010 Paul Oehler <poehler@interworx.com>
- added rhel6 support
* Thu Jul 8 2010 Paul Oehler <poehler@interworx.com>
- Added fefe's ipv6 patches
* Tue Jun 17 2008 Paul Oehler <poehler@interworx.com>
- Updated for Fedora 9
* Tue May 13 2008 Paul Oehler <poehler@interworx.com>
- Added support for Fedora 8
* Tue Jun 28 2004 Chris Wells <clwells@nexcess.net>
- Initial packaging as part of InterWorx-HAL OS
* Fri Jun 4 2004 Chris Wells <clwells@nexcess.net>
- updated for Fedora / CentOS
* Wed Aug 27 2003 Chris Wells <clwells@nexcess.net>
- initial release
